Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.sh revision 597 by niro, Mon Nov 5 16:47:10 2007 UTC branches/mage-next/src/smage2.in revision 2572 by niro, Wed Jan 29 12:24:35 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.59 2007-11-05 16:47:10 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
12    
 ## setup ##  
 PKGSUFFIX="mpk"  
 SRCPKGSUFFIX="mpks"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
 ## only for tests -> normally in /etc/rc.d/init.d/functions  
 COLRED="\033[1;6m\033[31m"  
 COLGREEN="\033[1;6m\033[32m"  
 COLYELLOW="\033[1;6m\033[33m"  
 COLBLUE="\033[1;6m\033[34m"  
 COLMAGENTA="\033[1;6m\033[35m"  
 COLWHITE="\033[1;6m\033[37m"  
 COLGRAY="\033[0;6m\033[37m"  
 COLBOLD="\033[1m"  
 COLDEFAULT="\033[0m"  
   
 if [[ ${NOCOLORS} = true ]]  
 then  
  COLRED=""  
  COLGREEN=""  
  COLYELLOW=""  
  COLBLUE=""  
  COLMAGENTA=""  
  COLWHITE=""  
  COLGRAY=""  
  COLBOLD=""  
  COLDEFAULT=""  
 fi  
   
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc.global  source /etc/mage.rc.global
17  source ${MAGERC}  source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21    # export default path
22    export PATH="${PATH}:${MLIBDIR}"
23    
24    ## setup ##
25    SMAGENAME="$1"
26    SMAGEVERSION="$(< ${MLIBDIR}/version)"
27    
28  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
29  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
30  then  then
31   export PKGDIR=${MROOT}/${PKGDIR}   export PKGDIR=${MROOT}/${PKGDIR}
# Line 59  then Line 33  then
33   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
34  fi  fi
35    
 showversion()  
 {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die()  
 {  
  xtitleclean  
  echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2()  
 {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  done  
   
  # clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum()  
 {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources()  
 {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? = 0 ]]  
  then  
  # md5's ok, no fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]  
  then  
  for mirror in ${SOURCEFORGE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]  
  then  
  for mirror in ${GNU_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]  
  then  
  for mirror in ${KDE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]  
  then  
  for mirror in ${GNOME_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare()  
 {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile()  
 {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install()  
 {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
 mlibdir()  
 {  
  local libdir=lib  
  [[ ${ARCH} = x86_64 ]] && libdir=lib64  
   
  echo "${libdir}"  
 }  
   
 mconfigure()  
 {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  --libdir=/usr/$(mlibdir) \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall()  
 {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ]  
  then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  libdir=${BINDIR}/usr/$(mlibdir) \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake()  
 {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack()  
 {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [[ -z $2 ]]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  [[ ! -d ${DEST} ]] && install -d ${DEST}  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."  
  ;;  
  rar)  
  unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."  
  ;;  
  zip)  
  unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."  
  ;;  
  rpm)  
  pushd ${BUILDDIR} > /dev/null  
  rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."  
  tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz/} || die "tar: .rpm unpack failed."  
  [[ -f ${BUILDDIR}/${SRCFILE/.rpm/.tar.gz/} ]] && rm ${BUILDDIR}/${SRCFILE/.rpm/.tar.gz/}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch()  
 {  
  local PATCHOPTS  
  local PATCHFILE  
  local i  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  if [[ -z $2 ]]  
  then  
  PATCHFILE=$1  
   
  ## patch level auto-detection, get patch level  
  for ((i=0; i < 10; i++))  
  do  
  patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null  
  if [[ $? = 0 ]]  
  then  
  PATCHOPTS="-Np${i}"  
  break  
  fi  
  done  
  fi  
   
  echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"  
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
 mlibtoolize()  
 {  
  local opts="$@"  
  [[ -z ${opts} ]] && opts="--copy --force"  
   
  libtoolize ${opts} || die "running: mlibtoolize ${opts}"  
 }  
   
 minstalldocs()  
 {  
  local docfiles  
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs()  
 {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins()  
 {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude()  
 {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment()  
 {  
  if [ -x /usr/bin/distcc ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
  # creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment()  
 {  
  if [ -x /usr/bin/ccache ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps()  
 {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  # ignore empty lines  
  [[ -z ${dep} ]] && continue  
   
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions wich should also be added  
 #                         warning: they get killed before the build starts !  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [ -n "$1" ] && target="-$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"  
  echo "${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.59 2007-11-05 16:47:10 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
   
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${target}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
   
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  echo >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  echo  >> ${dest}  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [ -z "${MAGE_TARGETS}" ]  
  then  
  echo  
  build_mage_script  
  echo  
  else  
   
  # build for each target an mage file  
  # run it with several targets  
  for i in ${MAGE_TARGETS}  
  do  
  echo  
  build_mage_script "${i}"  
  echo  
  done  
  fi  
  fi  
   
  # now unset all uneeded vars to be safe  
  # unset PKGNAME <-- don't do that; smage needs this var  
  # unset to be safe (quotes needed !)  
 # for i in ${SPECIAL_FUNCTIONS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_FUNCTIONS  
 # for i in ${SPECIAL_VARS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
   
 export_inherits()  
 {  
  local include="$1"  
  shift  
   
  while [ "$1" ]  
  do  
  local functions="$1"  
   
  # sanity checks  
  [ -z "${include}" ] && die "export_inherits(): \$include not given."  
  [ -z "${functions}" ] && die "export_inherits(): \$functions not given."  
   
  eval "${functions}() { ${include}_${functions} ; }"  
   
  # debug  
  [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"  
   
  shift  
  done  
 }  
   
 generate_package_md5sum()  
 {  
  local dest  
  local pcat  
  local pname  
  local pver  
  local pbuild  
  local parch  
  local target  
  local pkgname  
   
  # very basic getops  
  for i in $*  
  do  
  case $1 in  
  --pcat|-c) shift; pcat="$1" ;;  
  --pname|-n) shift; pname="$1" ;;  
  --pver|-v) shift; pver="$1" ;;  
  --pbuild|-b) shift; pbuild="$1" ;;  
  --parch|a) shift; parch="$1" ;;  
  --target|t) shift; target="$1" ;;  
  esac  
  shift  
  done  
   
  # sanity checks; abort if not given  
  [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."  
  [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."  
  [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."  
  [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."  
  [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."  
   
  # check needed global vars  
  [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."  
  [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."  
   
  # fix target as it may be empty !  
  [ -n "${target}" ] && target="-${target}"  
   
  # build pkgname  
  pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"  
   
  # build pkg-md5-sum only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"  
   
  # abort if not exist  
  if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]  
  then  
  echo -e "${COLRED}! exists${COLDEFAULT}"  
  return 0  
  fi  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # setup md5 dir  
  dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"  
  install -d ${dest}  
   
  # gen md5sum  
  ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \  
  > ${dest}/${pkgname}.md5  
  echo -e "${COLGREEN}done${COLDEFAULT}"  
  fi  
 }  
   
 source_pkg_build()  
 {  
  if [[ ${PKGTYPE} = virtual ]]  
  then  
  echo "Virtual package detected; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  if [[ ! -d ${SOURCEDIR}/${PNAME} ]]  
  then  
  echo "No SRC_URI defined; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."  
   
  echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"  
   
  # include the smage2 file  
  cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}  
   
  ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )  
  [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}  
  mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}  
   
  echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"  
 }  
   
   
36  # print out our version  # print out our version
37  showversion  showversion
38  echo  echo
39    
40  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
41  then  then
42   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
43   echo   echo
44   exit 1   exit 1
45  fi  fi
46    
47    # load supported mage features
48    load_mage_features
49    
50  # updating smage2-scripts  # updating smage2-scripts
51  if [[ $1 = update ]]  if [[ $1 = update ]]
52  then  then
# Line 959  fi Line 61  fi
61  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
62  if [[ $1 = calcmd5 ]]  if [[ $1 = calcmd5 ]]
63  then  then
64   if [ $# -ge 3 ]   if [ $# -ge 2 ]
65   then   then
66   SMAGENAME="$2"   SMAGENAME="$2"
67   MD5DIR="$3"   MD5DIR="$3"
68   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
69    
70     smagesource ${SMAGENAME} || die "download source failed"
71    
72   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
73   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 1015  then Line 119  then
119   echo   echo
120   else   else
121   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
122   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
123   echo   echo
124   echo   echo
125   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
# Line 1037  then Line 141  then
141   # get smage   # get smage
142   SMAGENAME="$2"   SMAGENAME="$2"
143   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
144   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
145    
146   download_sources   download_sources
147   exit 0   exit 0
# Line 1049  then Line 153  then
153   # set correct SMAGENAME   # set correct SMAGENAME
154   SMAGENAME="$2"   SMAGENAME="$2"
155   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
156   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
157    
158   regen_mage_tree   regen_mage_tree
159    
160   # build md5sum for existing packages   # build several subpackages
161   generate_package_md5sum \   if [[ -n ${SPLIT_PACKAGES} ]]
162   --pcat "${PCATEGORIE}" \   then
163   --pname "${PNAME}" \   split_save_variables
164   --pver "${PVER}" \   for subpackage in ${SPLIT_PACKAGES}
165   --pbuild "${PBUILD}" \   do
166   --parch "${ARCH}" \   # get the right variables for the split
167   --target "${target}"   export PNAME="${subpackage}"
168     split_info_${subpackage}
169     # fix PCATEGORIE -> PCAT
170     if [[ ! -z ${PCATEGORIE} ]]
171     then
172     PCAT="${PCATEGORIE}"
173     unset PCATEGORIE
174     fi
175     # build md5sum for existing packages
176     generate_package_md5sum \
177     --pcat "${PCAT}" \
178     --pname "${PNAME}" \
179     --pver "${PVER}" \
180     --pbuild "${PBUILD}" \
181     --parch "${ARCH}"
182     # restore smage environment
183     split_restore_variables
184     done
185     # unset all saved smage variables
186     split_unset_variables
187    
188     else
189     # build md5sum for existing packages
190     generate_package_md5sum \
191     --pcat "${PCAT}" \
192     --pname "${PNAME}" \
193     --pver "${PVER}" \
194     --pbuild "${PBUILD}" \
195     --parch "${ARCH}"
196     fi
197    
198   exit 0   exit 0
199  fi  fi
# Line 1073  then Line 206  then
206    
207   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
208    
209   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
210    
211   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
212   then   then
# Line 1089  fi Line 222  fi
222  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
223  then  then
224   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
225   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
226    
227   # abort if given file is not a source pkg   # abort if given file is not a source pkg
228   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1110  then Line 243  then
243   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
244  fi  fi
245    
246    if [ "$1" == "--resume" -a -n "$2" ]
247    then
248     msetfeature "resume"
249     SMAGENAME="$2"
250    fi
251    
252  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
253  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
# Line 1122  fi Line 260  fi
260  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
261  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
262    
263  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
264  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
265  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
266    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
267    
268  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
269  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
# Line 1132  echo -e "${COLGREEN}Compiling ${PKGNAME} Line 271  echo -e "${COLGREEN}Compiling ${PKGNAME}
271  # auto regen mage tree if requested  # auto regen mage tree if requested
272  regen_mage_tree  regen_mage_tree
273    
274  if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  if mqueryfeature "srcpkgbuild"
275  then  then
276   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
277   then   then
# Line 1142  then Line 281  then
281  fi  fi
282    
283  # download sources  # download sources
284  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
285    
286  # fixes some issues with these functions  # fixes some issues with these functions
287  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
288  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
289    export -f src_check || die "src_check export failed"
290  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
291    
292  # fixes some compile issues  # fixes some compile issues
293  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
294  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
295  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
296    then
297     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
298    else
299     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
300    fi
301    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
302  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
303  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
304    
   
305  # setup distcc  # setup distcc
306  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
307  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
308    
309  # setup ccache  # setup icecc
310  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
311    mqueryfeature "icecc" && setup_icecc_environment
312    
313  # small sleep to show our settings  # setup ccache
314  sleep 1  mqueryfeature "ccache" && setup_ccache_environment
315    
316  # cleans up build if a previously one exists  if mqueryfeature "resume"
 if [ -d ${BUILDDIR} ]  
317  then  then
318   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
319    
320     # setup build logging
321     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
322     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
323     then
324     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
325     fi
326     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
327    
328    else
329     # clean up builddir if a previously one exist
330     if [ -d ${BUILDDIR} ]
331     then
332     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
333     fi
334     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
335    
336     # clean up srcdir if a previously unpacked one exist
337     if [ -d ${SRCDIR} ]
338     then
339     rm -rf ${SRCDIR}
340     fi
341    
342     # clean up bindir if a previous build exist or create a new one
343     if [ -d ${BINDIR} ]
344     then
345     rm -rf ${BINDIR}
346     fi
347     install -d ${BINDIR} || die "couldn't create \$BINDIR."
348    
349     # clean up package temp dir if a previous build exist
350     if [ -d ${BUILDDIR}/${PKGNAME} ]
351     then
352     rm -rf ${BUILDDIR}/${PKGNAME}
353     fi
354    
355     # clean up stamps dir
356     if [ -d ${BUILDDIR}/.stamps ]
357     then
358     rm -rf ${BUILDDIR}/.stamps
359     fi
360    
361     # setup build logging
362     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
363     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
364  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
365    
366  # cleans up srcdir if a previously unpacked one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${SRCDIR} ]  
367  then  then
368   rm -rf ${SRCDIR}   echo "virtual package detected; nothing will be build ..."
369     # automatically set !pkgbuild here too
370     msetfeature "!pkgbuild"
371    else
372     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
373     die_pipestatus 0 "src_prepare failed"
374     resume_stamp src_prepare
375     step_by_step src_prepare
376    
377     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
378     die_pipestatus 0 "src_compile failed"
379     resume_stamp src_compile
380     step_by_step src_compile
381    
382     # only run checks if requested
383     if mqueryfeature "!check"
384     then
385     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
386     else
387     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
388     die_pipestatus 0 "src_check failed"
389     resume_stamp src_check
390     fi
391     step_by_step src_check
392    
393     # build several subpackages
394     if [[ -n ${SPLIT_PACKAGES} ]]
395     then
396     # save bindir & pname
397     split_save_variables
398     export SAVED_BINDIR="${BINDIR}"
399     for subpackage in ${SPLIT_PACKAGES}
400     do
401     split_info_${subpackage}
402     if [[ ${PKGTYPE} = virtual ]]
403     then
404     echo
405     echo -en "${COLBLUE}*** ${COLDEFAULT}"
406     echo -en "Virtual package detected"
407     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
408     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
409    
410     echo "virtual package detected; nothing will be build ..."
411     # automatically set !pkgbuild here too
412     msetfeature "!pkgbuild"
413     else
414     if typeset -f src_install_${subpackage} > /dev/null
415     then
416     # export subpackage bindir
417     export BINDIR="${SAVED_BINDIR}_${subpackage}"
418     # export PNAME, several internal function and include
419     # rely on this variable
420     export PNAME="${subpackage}"
421    
422     echo
423     echo -en "${COLBLUE}*** ${COLDEFAULT}"
424     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
425     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
426     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
427    
428     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
429     die_pipestatus 0 "src_install_${subpackage} failed"
430     resume_stamp src_install_${subpackage}
431     step_by_step src_install_${subpackage}
432     fi
433     fi
434     # restore smage environment
435     split_restore_variables
436     done
437     # unset all saved smage variables
438     split_unset_variables
439     else
440     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
441     die_pipestatus 0 "src_install failed"
442     resume_stamp src_install
443     step_by_step src_install
444     fi
445  fi  fi
446    
447  # cleans up bindir if a previous build exists or creates a new one  # echo for sake of good-looking
448  if [ -d ${BINDIR} ]  echo
449    
450    if mqueryfeature "!compressdoc"
451    then
452     echo -e "!compressdoc detected; documentation will not be compressed ..."
453    elif mqueryfeature "!pkgbuild"
454  then  then
455   rm -rf ${BINDIR}   echo "!pkgbuild detected; skipping documentation compression..."
456    else
457     # compressing doc, info & man files
458     if [[ -n ${SPLIT_PACKAGES} ]]
459     then
460     # save smage environment
461     split_save_variables
462     for subpackage in ${SPLIT_PACKAGES}
463     do
464     # honor split_info
465     split_info_${subpackage}
466     if [[ ${PKGTYPE} = virtual ]]
467     then
468     # automatically set !pkgbuild here too
469     msetfeature "!pkgbuild"
470     fi
471    
472     if mqueryfeature "!compressdoc"
473     then
474     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
475     elif mqueryfeature "!pkgbuild"
476     then
477     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
478     else
479     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
480     resume_stamp post-mcompressdoc_${subpackage}
481     fi
482     # restore smage environment
483     split_restore_variables
484     done
485     # unset saved variables
486     split_unset_variables
487     else
488     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
489     resume_stamp post-mcompressdoc
490     fi
491  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
492    
493  # cleans up package temp dir if a previous build exists  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
494  then  then
495   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
496     then
497     echo "!pkgbuild detected; skipping libtool archive stripping ..."
498     else
499     if [[ -n ${SPLIT_PACKAGES} ]]
500     then
501     # save smage environment
502     split_save_variables
503     for subpackage in ${SPLIT_PACKAGES}
504     do
505     # honor split_info
506     split_info_${subpackage}
507     if [[ ${PKGTYPE} = virtual ]]
508     then
509     # automatically set !pkgbuild here too
510     msetfeature "!pkgbuild"
511     fi
512    
513     if mqueryfeature "!libtool"
514     then
515     if mqueryfeature "!pkgbuild"
516     then
517     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
518     else
519     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
520     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
521     resume_stamp post-mstriplibtoolarchive_${subpackage}
522     fi
523     fi
524    
525     # restore smage environment
526     split_restore_variables
527     done
528     # unset saved variables
529     split_unset_variables
530     else
531     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
532     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
533     resume_stamp post-mstriplibtoolarchive
534     fi
535     fi
536  fi  fi
537    
538  # cleans up timestamp if one exists  if mqueryfeature "purge"
 if [ -f /var/tmp/timestamp ]  
539  then  then
540   mage rmstamp   if mqueryfeature "!pkgbuild"
541  fi   then
542     echo "!pkgbuild detected; skipping file purgation ..."
543     else
544     if [[ -n ${SPLIT_PACKAGES} ]]
545     then
546     # save smage environment
547     split_save_variables
548     for subpackage in ${SPLIT_PACKAGES}
549     do
550     # honor split_info
551     split_info_${subpackage}
552     if [[ ${PKGTYPE} = virtual ]]
553     then
554     # automatically set !pkgbuild here too
555     msetfeature "!pkgbuild"
556     fi
557    
558  src_prepare || die "src_prepare failed"   if mqueryfeature "purge"
559  src_compile || die "src_compile failed"   then
560  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
561     then
562     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
563     else
564     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
565     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
566     resume_stamp post-mpurgetargets_${subpackage}
567     fi
568     fi
569    
570     # restore smage environment
571     split_restore_variables
572     done
573     # unset saved variables
574     split_unset_variables
575     else
576     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
577     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
578     resume_stamp post-mpurgetargets
579     fi
580     fi
581    fi
582    
583  # compressing doc, info & man files  # stripping all bins and libs
584  if [ -d ${BUILDDIR}/builded/usr/share/man ]  if mqueryfeature "!strip"
585  then  then
586   echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"   echo -e "!strip detected; package will not be stripped ..."
587   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man  elif mqueryfeature "!pkgbuild"
588    then
589     echo "!pkgbuild detected; skipping stripping of the package ..."
590    else
591     if [[ -n ${SPLIT_PACKAGES} ]]
592     then
593     # save smage environment
594     split_save_variables
595     for subpackage in ${SPLIT_PACKAGES}
596     do
597     # honor split_info
598     split_info_${subpackage}
599     if [[ ${PKGTYPE} = virtual ]]
600     then
601     # automatically set !pkgbuild here too
602     msetfeature "!pkgbuild"
603     fi
604    
605     if mqueryfeature "!strip"
606     then
607     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
608     elif mqueryfeature "!pkgbuild"
609     then
610     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
611     else
612     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
613     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
614     resume_stamp post-mstripbins_${subpackage}
615     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
616     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
617     resume_stamp post-mstriplibs_${subpackage}
618     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
619     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
620     resume_stamp post-mstripstatic_${subpackage}
621     fi
622    
623     # restore smage environment
624     split_restore_variables
625     done
626     # unset saved variables
627     split_unset_variables
628     else
629     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
630     run_resume post-mstripbins || mstripbins ${BINDIR}
631     resume_stamp post-mstripbins
632     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
633     run_resume post-mstriplibs || mstriplibs ${BINDIR}
634     resume_stamp post-mstriplibs
635     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
636     run_resume post-mstripstatic || mstripstatic ${BINDIR}
637     resume_stamp post-mstripstatic
638     fi
639  fi  fi
640    
641  if [ -d ${BUILDDIR}/builded/usr/share/info ]  if mqueryfeature "qalint"
642  then  then
643   echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"   if mqueryfeature "!pkgbuild"
644   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   then
645     echo "!pkgbuild detected; skipping QA lint checks ..."
646     else
647     if [[ -n ${SPLIT_PACKAGES} ]]
648     then
649     # save smage environment
650     split_save_variables
651     for subpackage in ${SPLIT_PACKAGES}
652     do
653     # honor split_info
654     split_info_${subpackage}
655     if [[ ${PKGTYPE} = virtual ]]
656     then
657     # automatically set !pkgbuild here too
658     msetfeature "!pkgbuild"
659     fi
660    
661     if mqueryfeature "qalint"
662     then
663     if mqueryfeature "!pkgbuild"
664     then
665     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
666     else
667     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
668     mqalint ${BINDIR}_${subpackage}
669     fi
670     fi
671    
672     # restore smage environment
673     split_restore_variables
674     done
675     # unset saved variables
676     split_unset_variables
677     else
678     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
679     mqalint ${BINDIR}
680     fi
681     fi
682  fi  fi
683    
684  # stripping all bins and libs  if mqueryfeature "!pkgbuild"
685  case ${NOSTRIP} in  then
686   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
687   echo -e "NOSTRIP=true detected; Package will not be stripped ..."  else
688   ;;   # build several subpackages
689   *)   if [[ -n ${SPLIT_PACKAGES} ]]
  echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"  
  mstripbins ${BINDIR}  
  echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 # the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  # build several targets  
  if [ -n "${MAGE_TARGETS}" ]  
690   then   then
691   for target in ${MAGE_TARGETS}   split_save_variables
692     for subpackage in ${SPLIT_PACKAGES}
693   do   do
694   # check if an special target_pkgbuild exists   # get the right variables for the split
695   if typeset -f ${target}_pkgbuild > /dev/null   export PNAME="${subpackage}"
696     split_info_${PNAME}
697     # fix PCATEGORIE -> PCAT
698     if [[ ! -z ${PCATEGORIE} ]]
699     then
700     PCAT="${PCATEGORIE}"
701     unset PCATEGORIE
702     fi
703     if [[ ${PKGTYPE} = virtual ]]
704     then
705     # automatically set !pkgbuild here too
706     msetfeature "!pkgbuild"
707     fi
708    
709     # jump to next one if !pkgbuild is set in split_info
710     if mqueryfeature "!pkgbuild"
711     then
712     # restore smage environment
713     split_restore_variables
714     continue
715     fi
716    
717     # check if an special subpackage_pkgbuild exists
718     if typeset -f ${PNAME}_pkgbuild > /dev/null
719   then   then
720   # run it   # run it
721   ${target}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
722     resume_stamp post-${PNAME}_pkgbuild
723   fi   fi
724   # now create the target package   # now create the target package
725   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
726   "${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
727   ${BINDIR} || die "target: ${target} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
728     resume_stamp post-pkg_builddir_${PNAME}
729    
730   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
731   generate_package_md5sum \   run_resume post-md5sum_${PNAME} || generate_package_md5sum \
732   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
733   --pname "${PNAME}" \   --pname "${PNAME}" \
734   --pver "${PVER}" \   --pver "${PVER}" \
735   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
736   --parch "${ARCH}" \   --parch "${ARCH}"
737   --target "${target}"   resume_stamp post-md5sum_${PNAME}
738    
739     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
740    
741   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   # restore smage environment
742     split_restore_variables
743   done   done
744     # unset all saved smage variables
745     split_unset_variables
746    
747   else   else
748   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
749     resume_stamp post-pkg_builddir
750    
751   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
752   generate_package_md5sum \   run_resume post-md5sum || generate_package_md5sum \
753   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
754   --pname "${PNAME}" \   --pname "${PNAME}" \
755   --pver "${PVER}" \   --pver "${PVER}" \
756   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
757   --parch "${ARCH}"   --parch "${ARCH}"
758     resume_stamp post-md5sum
759    
760   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
761   fi   fi
762    
763   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
764   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   if mqueryfeature "srcpkgbuild"
765   ;;   then
766  esac   run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
767     resume_stamp post-srcpkgbuild
768  # for sure   fi
769  unset NOPKGBUILD  fi
770  unset NOSTRIP  
771    if mqueryfeature "buildlog"
772    then
773     bzip2 -9f /var/log/smage/${PKGNAME}.log
774    else
775     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
776    fi
777    
778  xtitleclean  xtitleclean

Legend:
Removed from v.597  
changed lines
  Added in v.2572